import _m0 from 'protobufjs/minimal';
import { Any } from './google/protobuf/any';
export declare const protobufPackage = "pocketjs";
export interface ProtoStdTx {
    msg: Any | undefined;
    fee: Coin[];
    signature: ProtoStdSignature | undefined;
    memo: string;
    entropy: number;
}
export interface ProtoStdSignature {
    publicKey: Uint8Array;
    Signature: Uint8Array;
}
export interface StdSignDoc {
    ChainID: string;
    fee: Uint8Array;
    memo: string;
    msg: Uint8Array;
    entropy: number;
}
export interface Coin {
    denom: string;
    amount: string;
}
/**
 * DecCoin defines a token with a denomination and a decimal amount.
 *
 * NOTE: The amount field is an Dec which implements the custom method
 * signatures required by gogoproto.
 */
export interface DecCoin {
    denom: string;
    amount: string;
}
export interface MsgProtoStake {
    pubKey: Uint8Array;
    chains: string[];
    value: string;
}
export interface MsgBeginUnstake {
    Address: Uint8Array;
}
export interface MsgUnjail {
    AppAddr: Uint8Array;
}
export interface MsgProtoNodeStake8 {
    Publickey: Uint8Array;
    Chains: string[];
    value: string;
    ServiceUrl: string;
    OutAddress: Uint8Array;
}
export interface MsgBeginNodeUnstake8 {
    Address: Uint8Array;
    Signer: Uint8Array;
}
export interface MsgNodeUnjail {
    ValidatorAddr: Uint8Array;
}
export interface MsgNodeUnjail8 {
    ValidatorAddr: Uint8Array;
    Signer: Uint8Array;
}
export interface MsgSend {
    FromAddress: Uint8Array;
    ToAddress: Uint8Array;
    amount: string;
}
export interface MsgDAOTransfer {
    fromAddress: Uint8Array;
    toAddress: Uint8Array;
    amount: string;
    action: string;
}
export interface Upgrade {
    height: number;
    version: string;
    oldUpgradeHeight: number;
    features: string[];
}
export interface MsgUpgrade {
    address: Uint8Array;
    upgrade: Upgrade | undefined;
}
export interface MsgChangeParam {
    FromAddress: Uint8Array;
    paramKey: string;
    paramVal: Uint8Array;
}
export declare const ProtoStdTx: {
    encode(message: ProtoStdTx, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): ProtoStdTx;
    fromJSON(object: any): ProtoStdTx;
    toJSON(message: ProtoStdTx): unknown;
    fromPartial<I extends {
        msg?: {
            typeUrl?: string | undefined;
            value?: Uint8Array | undefined;
        } | undefined;
        fee?: {
            denom?: string | undefined;
            amount?: string | undefined;
        }[] | undefined;
        signature?: {
            publicKey?: Uint8Array | undefined;
            Signature?: Uint8Array | undefined;
        } | undefined;
        memo?: string | undefined;
        entropy?: number | undefined;
    } & {
        msg?: ({
            typeUrl?: string | undefined;
            value?: Uint8Array | undefined;
        } & {
            typeUrl?: string | undefined;
            value?: Uint8Array | undefined;
        } & Record<Exclude<keyof I["msg"], keyof Any>, never>) | undefined;
        fee?: ({
            denom?: string | undefined;
            amount?: string | undefined;
        }[] & ({
            denom?: string | undefined;
            amount?: string | undefined;
        } & {
            denom?: string | undefined;
            amount?: string | undefined;
        } & Record<Exclude<keyof I["fee"][number], keyof Coin>, never>)[] & Record<Exclude<keyof I["fee"], keyof {
            denom?: string | undefined;
            amount?: string | undefined;
        }[]>, never>) | undefined;
        signature?: ({
            publicKey?: Uint8Array | undefined;
            Signature?: Uint8Array | undefined;
        } & {
            publicKey?: Uint8Array | undefined;
            Signature?: Uint8Array | undefined;
        } & Record<Exclude<keyof I["signature"], keyof ProtoStdSignature>, never>) | undefined;
        memo?: string | undefined;
        entropy?: number | undefined;
    } & Record<Exclude<keyof I, keyof ProtoStdTx>, never>>(object: I): ProtoStdTx;
};
export declare const ProtoStdSignature: {
    encode(message: ProtoStdSignature, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): ProtoStdSignature;
    fromJSON(object: any): ProtoStdSignature;
    toJSON(message: ProtoStdSignature): unknown;
    fromPartial<I extends {
        publicKey?: Uint8Array | undefined;
        Signature?: Uint8Array | undefined;
    } & {
        publicKey?: Uint8Array | undefined;
        Signature?: Uint8Array | undefined;
    } & Record<Exclude<keyof I, keyof ProtoStdSignature>, never>>(object: I): ProtoStdSignature;
};
export declare const StdSignDoc: {
    encode(message: StdSignDoc, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): StdSignDoc;
    fromJSON(object: any): StdSignDoc;
    toJSON(message: StdSignDoc): unknown;
    fromPartial<I extends {
        ChainID?: string | undefined;
        fee?: Uint8Array | undefined;
        memo?: string | undefined;
        msg?: Uint8Array | undefined;
        entropy?: number | undefined;
    } & {
        ChainID?: string | undefined;
        fee?: Uint8Array | undefined;
        memo?: string | undefined;
        msg?: Uint8Array | undefined;
        entropy?: number | undefined;
    } & Record<Exclude<keyof I, keyof StdSignDoc>, never>>(object: I): StdSignDoc;
};
export declare const Coin: {
    encode(message: Coin, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Coin;
    fromJSON(object: any): Coin;
    toJSON(message: Coin): unknown;
    fromPartial<I extends {
        denom?: string | undefined;
        amount?: string | undefined;
    } & {
        denom?: string | undefined;
        amount?: string | undefined;
    } & Record<Exclude<keyof I, keyof Coin>, never>>(object: I): Coin;
};
export declare const DecCoin: {
    encode(message: DecCoin, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): DecCoin;
    fromJSON(object: any): DecCoin;
    toJSON(message: DecCoin): unknown;
    fromPartial<I extends {
        denom?: string | undefined;
        amount?: string | undefined;
    } & {
        denom?: string | undefined;
        amount?: string | undefined;
    } & Record<Exclude<keyof I, keyof DecCoin>, never>>(object: I): DecCoin;
};
export declare const MsgProtoStake: {
    encode(message: MsgProtoStake, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgProtoStake;
    fromJSON(object: any): MsgProtoStake;
    toJSON(message: MsgProtoStake): unknown;
    fromPartial<I extends {
        pubKey?: Uint8Array | undefined;
        chains?: string[] | undefined;
        value?: string | undefined;
    } & {
        pubKey?: Uint8Array | undefined;
        chains?: (string[] & string[] & Record<Exclude<keyof I["chains"], keyof string[]>, never>) | undefined;
        value?: string | undefined;
    } & Record<Exclude<keyof I, keyof MsgProtoStake>, never>>(object: I): MsgProtoStake;
};
export declare const MsgBeginUnstake: {
    encode(message: MsgBeginUnstake, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgBeginUnstake;
    fromJSON(object: any): MsgBeginUnstake;
    toJSON(message: MsgBeginUnstake): unknown;
    fromPartial<I extends {
        Address?: Uint8Array | undefined;
    } & {
        Address?: Uint8Array | undefined;
    } & Record<Exclude<keyof I, "Address">, never>>(object: I): MsgBeginUnstake;
};
export declare const MsgUnjail: {
    encode(message: MsgUnjail, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgUnjail;
    fromJSON(object: any): MsgUnjail;
    toJSON(message: MsgUnjail): unknown;
    fromPartial<I extends {
        AppAddr?: Uint8Array | undefined;
    } & {
        AppAddr?: Uint8Array | undefined;
    } & Record<Exclude<keyof I, "AppAddr">, never>>(object: I): MsgUnjail;
};
export declare const MsgProtoNodeStake8: {
    encode(message: MsgProtoNodeStake8, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgProtoNodeStake8;
    fromJSON(object: any): MsgProtoNodeStake8;
    toJSON(message: MsgProtoNodeStake8): unknown;
    fromPartial<I extends {
        Publickey?: Uint8Array | undefined;
        Chains?: string[] | undefined;
        value?: string | undefined;
        ServiceUrl?: string | undefined;
        OutAddress?: Uint8Array | undefined;
    } & {
        Publickey?: Uint8Array | undefined;
        Chains?: (string[] & string[] & Record<Exclude<keyof I["Chains"], keyof string[]>, never>) | undefined;
        value?: string | undefined;
        ServiceUrl?: string | undefined;
        OutAddress?: Uint8Array | undefined;
    } & Record<Exclude<keyof I, keyof MsgProtoNodeStake8>, never>>(object: I): MsgProtoNodeStake8;
};
export declare const MsgBeginNodeUnstake8: {
    encode(message: MsgBeginNodeUnstake8, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgBeginNodeUnstake8;
    fromJSON(object: any): MsgBeginNodeUnstake8;
    toJSON(message: MsgBeginNodeUnstake8): unknown;
    fromPartial<I extends {
        Address?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & {
        Address?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & Record<Exclude<keyof I, keyof MsgBeginNodeUnstake8>, never>>(object: I): MsgBeginNodeUnstake8;
};
export declare const MsgNodeUnjail: {
    encode(message: MsgNodeUnjail, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgNodeUnjail;
    fromJSON(object: any): MsgNodeUnjail;
    toJSON(message: MsgNodeUnjail): unknown;
    fromPartial<I extends {
        ValidatorAddr?: Uint8Array | undefined;
    } & {
        ValidatorAddr?: Uint8Array | undefined;
    } & Record<Exclude<keyof I, "ValidatorAddr">, never>>(object: I): MsgNodeUnjail;
};
export declare const MsgNodeUnjail8: {
    encode(message: MsgNodeUnjail8, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgNodeUnjail8;
    fromJSON(object: any): MsgNodeUnjail8;
    toJSON(message: MsgNodeUnjail8): unknown;
    fromPartial<I extends {
        ValidatorAddr?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & {
        ValidatorAddr?: Uint8Array | undefined;
        Signer?: Uint8Array | undefined;
    } & Record<Exclude<keyof I, keyof MsgNodeUnjail8>, never>>(object: I): MsgNodeUnjail8;
};
export declare const MsgSend: {
    encode(message: MsgSend, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgSend;
    fromJSON(object: any): MsgSend;
    toJSON(message: MsgSend): unknown;
    fromPartial<I extends {
        FromAddress?: Uint8Array | undefined;
        ToAddress?: Uint8Array | undefined;
        amount?: string | undefined;
    } & {
        FromAddress?: Uint8Array | undefined;
        ToAddress?: Uint8Array | undefined;
        amount?: string | undefined;
    } & Record<Exclude<keyof I, keyof MsgSend>, never>>(object: I): MsgSend;
};
export declare const MsgDAOTransfer: {
    encode(message: MsgDAOTransfer, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgDAOTransfer;
    fromJSON(object: any): MsgDAOTransfer;
    toJSON(message: MsgDAOTransfer): unknown;
    fromPartial<I extends {
        fromAddress?: Uint8Array | undefined;
        toAddress?: Uint8Array | undefined;
        amount?: string | undefined;
        action?: string | undefined;
    } & {
        fromAddress?: Uint8Array | undefined;
        toAddress?: Uint8Array | undefined;
        amount?: string | undefined;
        action?: string | undefined;
    } & Record<Exclude<keyof I, keyof MsgDAOTransfer>, never>>(object: I): MsgDAOTransfer;
};
export declare const Upgrade: {
    encode(message: Upgrade, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Upgrade;
    fromJSON(object: any): Upgrade;
    toJSON(message: Upgrade): unknown;
    fromPartial<I extends {
        height?: number | undefined;
        version?: string | undefined;
        oldUpgradeHeight?: number | undefined;
        features?: string[] | undefined;
    } & {
        height?: number | undefined;
        version?: string | undefined;
        oldUpgradeHeight?: number | undefined;
        features?: (string[] & string[] & Record<Exclude<keyof I["features"], keyof string[]>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof Upgrade>, never>>(object: I): Upgrade;
};
export declare const MsgUpgrade: {
    encode(message: MsgUpgrade, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgUpgrade;
    fromJSON(object: any): MsgUpgrade;
    toJSON(message: MsgUpgrade): unknown;
    fromPartial<I extends {
        address?: Uint8Array | undefined;
        upgrade?: {
            height?: number | undefined;
            version?: string | undefined;
            oldUpgradeHeight?: number | undefined;
            features?: string[] | undefined;
        } | undefined;
    } & {
        address?: Uint8Array | undefined;
        upgrade?: ({
            height?: number | undefined;
            version?: string | undefined;
            oldUpgradeHeight?: number | undefined;
            features?: string[] | undefined;
        } & {
            height?: number | undefined;
            version?: string | undefined;
            oldUpgradeHeight?: number | undefined;
            features?: (string[] & string[] & Record<Exclude<keyof I["upgrade"]["features"], keyof string[]>, never>) | undefined;
        } & Record<Exclude<keyof I["upgrade"], keyof Upgrade>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof MsgUpgrade>, never>>(object: I): MsgUpgrade;
};
export declare const MsgChangeParam: {
    encode(message: MsgChangeParam, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): MsgChangeParam;
    fromJSON(object: any): MsgChangeParam;
    toJSON(message: MsgChangeParam): unknown;
    fromPartial<I extends {
        FromAddress?: Uint8Array | undefined;
        paramKey?: string | undefined;
        paramVal?: Uint8Array | undefined;
    } & {
        FromAddress?: Uint8Array | undefined;
        paramKey?: string | undefined;
        paramVal?: Uint8Array | undefined;
    } & Record<Exclude<keyof I, keyof MsgChangeParam>, never>>(object: I): MsgChangeParam;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
declare type KeysOfUnion<T> = T extends T ? keyof T : never;
export declare type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & Record<Exclude<keyof I, KeysOfUnion<P>>, never>;
export {};
//# sourceMappingURL=tx-signer.d.ts.map